import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class ControllableUnit here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ControllableUnit extends Unit
{
    /**
     * Act - do whatever the ControllableUnit wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
   ArrayList<Effect> Effects;
   int Level=1;
   public ControllableUnit()
   {
       Effects=new ArrayList();
       Health=5;
       ProjectileClass=GreenLaser.class;
       EnemyClass=AIUnit.class;
       YShotOffset=-20;
       DestroyingSound="XWing explode.mp3";
       ShotSound="XWing fire.mp3";
   }
   public void defaultShot()
   {
       if(Level==1)
       {
          shoot(-90);
       }
       else if(Level==2)
       {
          shoot(-90,-20);
          shoot(-90,20);
       }
       else
       {
          shoot(-90,-20);
          shoot(-90,20);
          shoot(-90);
       }
       Greenfoot.playSound(ShotSound);
   }
   public void onHit(Projectile proj)
   {
       if(proj instanceof RedLaser)
       {
           
           for(Effect e:Effects)
           {
               if(e instanceof ShieldEffect)
               {
                   ((ShieldEffect)e).ShieldHit(proj);
                   return;
               }
           }
           getWorld().removeObject(proj);
           Health--;
           if(Health==0)
           {
               getWorld().removeObject(this);
           }
 
       }
   }
   public void act() 
   {
       // move(-1);
        //new ProjClass();
        ShootDelay++;
        World w=getWorld();
        for(int a=0;a<2;a++)
        {
            
            
            if(a<Effects.size())
            {
                Effect e=Effects.get(a);
                e.tick();
                if(e.LeftTime!=0)
                {
                   w.showText(e.Name+" "+e.LeftTime/60,80,360-a*20);
                }
               
            }
            else
            {
                w.showText("",80,360-a*20);
            }
        }
        if(Greenfoot.isKeyDown("d") || Greenfoot.isKeyDown("в"))
        {
            move(5);
           // setRotation(rot+1);
        }
        if(Greenfoot.isKeyDown("a")|| Greenfoot.isKeyDown("ф"))
        {
            move(-5);
            //setRotation(rot-1);
        }
        if(Greenfoot.isKeyDown("w")|| Greenfoot.isKeyDown("ц"))
        {
            if(ShootDelay%20==0 || ShootDelay>21)
            {
               //World w=getWorld();
               //GreenLaser ball=new GreenLaser(Enemy.class,-1,"G:/Java Prog/scen1/XWing explode.mp3");
               //w.addObject(ball,getX(),getY()-40);
               //ball.setRotation(-90);
               Greenfoot.playSound(ShotSound);
               defaultShot();
               //shoot(-90);
               ShootDelay=0;
               
            }
            //setRotation(rot-1);
        }

        // Add your action code here.
    }       
}
